/******************************************************************************

	ui_text.c

	[UC^tF[XeLXgǗ

******************************************************************************/

#include "psp.h"

#if !JAPANESE_UI

const char *ui_text[UI_TEXT_MAX] =
{
	"\0",
	"\n",

	/* psp/filer.c */
	"Please wait...",
	"Could not open zipname.%s",

	/* psp/sound.c */
	"Could not reserve audio channel for sound.",
	"Could not start sound thread.",

	/* psp/ui.c */
	"Warning: Battery is low (%d%%). Please charge battery!",

	FONT_CIRCLE " to launch, " FONT_CROSS " to cancel",
	FONT_CIRCLE " to confirm, " FONT_CROSS " to cancel",
#ifdef SAVE_STATE
	FONT_CIRCLE " return to game, " FONT_CROSS " return to menu",
#endif
	"Press any button.",
	"Start emulation.",
#ifdef ADHOC
	"Start emulation. (AdHoc)",
#endif
	"Exit emulation.",
	"Reset emulation.",
	"Need to restart emulation.",
#if (EMU_SYSTEM != NCDZ)
	"THIS GAME DOESN'T WORK.",
	"You won't be able to make it work correctly.",
	"Don't bother.",
#endif
	"Do you make this directory the startup directory?",
#ifdef SAVE_STATE
	"Start save state.",
	"Start load state.",
	"Complete.",
	"Delete state file.",
#endif
#if (EMU_SYSTEM == NCDZ)
	"MP3 files not found. CDDA cannot play.",
	"IPL.TXT not found.",
	"Boot NEOGEO CDZ BIOS.",
	"NEOGEO CDZ BIOS (neocd.bin) not found.",
	"Invalid NEOGEO CDZ BIOS found.",
	"Cannot launch game.",
#endif

	"Help - %s",
	"Not use",
	"Press any button to return to menu.",
	"File browser",
	"Scroll",
	"Scroll 1 page",
	"Launch game",
	"Launch game (AdHoc)",
	"Exit emulator",
	"Show BIOS select menu",
	"Open color settings menu",
	"Show this help",
	"Boot BIOS",
	"Set selected directory as startup",
	"Change value",
	"Select",
	"Select slot",
	"Change function",
	"Execute function",
	"Select item",
	"Select item / Change value",
	"RGB value +5",
	"Return to file browser",
	"RGB value -5",
	"Restore all values to default",
	"Scroll / Select item",
	"Open / Close item menu",
	"Return to main menu / game",

	/* psp/ui_menu.c */
	"On",
	"Off",
	"Yes",
	"No",
	"Enable",
	"Disable",
	"Return to main menu",
	"Game configuration menu",
	"Raster Effects",
	"Stretch Screen",
#if (EMU_SYSTEM == CPS1 || EMU_SYSTEM == CPS2)
	"360x270 (4:3)",
	"384x270 (24:17)",
	"480x270 (16:9)",
	"Rotate Screen",
#else
	"360x270 (4:3)",
	"420x270 (14:9)",
	"480x270 (16:9)",
#endif
	"Video Sync",
	"Auto Frameskip",
	"Frameskip",
	"level 1",
	"level 2",
	"level 3",
	"level 4",
	"level 5",
	"level 6",
	"level 7",
	"level 8",
	"level 9",
	"level 10",
	"level 11",
	"Show FPS",
	"60fps Limit",
	"Enable Sound",
	"Sample Rate",
	"11025Hz",
	"22050Hz",
	"44100Hz",
	"Sound Volume",
	"0%",
	"10%",
	"20%",
	"30%",
	"40%",
	"50%",
	"60%",
	"70%",
	"80%",
	"90%",
	"100%",
	"Controller",
	"Player 1",
	"Player 2",
#if (EMU_SYSTEM == CPS1 || EMU_SYSTEM == CPS2)
	"Player 3",
	"Player 4",
#endif
	"PSP clock",
	"222MHz",
	"266MHz",
	"333MHz",
#if (EMU_SYSTEM == MVS)
	"Default",
#endif
#if (EMU_SYSTEM == MVS || EMU_SYSTEM == NCDZ)
	"Machine Region",
	"Japan",
	"USA",
	"Europe",
#endif
#if (EMU_SYSTEM == MVS)
	"Machine Mode",
	"Console (AES)",
	"Arcade (MVS)",
#endif
#if (EMU_SYSTEM == NCDZ)
	"Emulate Load Screen",
	"CD-ROM Speed Limit",
	"Enable CDDA",
	"CDDA Volume",
#endif

	"Key configuration menu",
	"Not use",
	FONT_UPARROW,
	FONT_DOWNARROW,
	FONT_LEFTARROW,
	FONT_RIGHTARROW,
	FONT_CIRCLE,
	FONT_CROSS,
	FONT_SQUARE,
	FONT_TRIANGLE,
	"L TRIGGER",
	"R TRIGGER",
	"START",
	"SELECT",
	"Low",
	"Normal",
	"High",
#if (EMU_SYSTEM == CPS2)
	"Player1 Start",
	"Player2 Start",
#endif
	"%d frame",
	"%d frames",
	FONT_UPARROW,
	FONT_DOWNARROW,
	FONT_LEFTARROW,
	FONT_RIGHTARROW,
#if (EMU_SYSTEM == MVS || EMU_SYSTEM == NCDZ)
	"Button A",
	"Button B",
	"Button C",
	"Button D",
#else
	"Button 1",
	"Button 2",
	"Button 3",
	"Button 4",
	"Button 5",
	"Button 6",
#endif
	"Start",
#if (EMU_SYSTEM == NCDZ)
	"Select",
#else
	"Coin",
	"Service Coin",
#endif
#if (EMU_SYSTEM == MVS)
	"Test Switch",
#elif (EMU_SYSTEM != NCDZ)
	"Service Switch",
#endif
#if (EMU_SYSTEM == MVS || EMU_SYSTEM == NCDZ)
	"Autofire A",
	"Autofire B",
	"Autofire C",
	"Autofire D",
#else
	"Autofire 1",
	"Autofire 2",
	"Autofire 3",
	"Autofire 4",
	"Autofire 5",
	"Autofire 6",
#endif
	"Autofire Interval",
#if (EMU_SYSTEM == MVS || EMU_SYSTEM == NCDZ)
	"Hotkey A+B",
	"Hotkey A+C",
	"Hotkey A+D",
	"Hotkey B+C",
	"Hotkey B+D",
	"Hotkey C+D",
	"Hotkey A+B+C",
	"Hotkey A+B+D",
	"Hotkey A+C+D",
	"Hotkey B+C+D",
	"Hotkey A+B+C+D",
#endif
#if (EMU_SYSTEM != NCDZ)
	"Analog Sensitivity",
#endif
#if (EMU_SYSTEM == CPS1)
	"Dial (Left)",
	"Dial (Right)",
	"Pause",
#endif
#if (EMU_SYSTEM == CPS2)
	"Paddle (Left)",
	"Paddle (Right)",
#endif
#if (EMU_SYSTEM == MVS)
	"Big",
	"Small",
	"Double Up",
	"Start/Collect",
	"Payout",
	"Cancel",
	"Bet",
	"Bet/Cancel All",
	"Operator Menu",
	"Clear Credit",
	"Hopper Out",
#endif
	"Save Screenshot",
	"Switch Player",

	"DIP switch settings menu",
	"This game has no DIP switches.",

	"Save/Load State",
	"Slot %d:",
	"Empty",
	"Load",
	"Delete",
	"Save",
	"Play Date",
	"Save Time",
	"Version",
	"Faild to delete file \"%s\".",

	"Main menu",
	"Game configuration",
	"Change game settings.",
	"Key configuration",
	"Change buttons and autofire/hotkey settings.",
#if (EMU_SYSTEM != NCDZ)
	"DIP switch settings",
	"Change hardware DIP switch settings.",
#endif
	"Reset emulation",
	"Reset " SYSTEM_NAME " emulation.",
	"Return to file browser",
	"Stop emulation and return to file browser.",
	"Return to game",
	"Return to game emulation.",
	"Exit emulator",
	"Exit emulation and return to PSP menu.",
#ifdef COMMAND_LIST
	"Show command list",
	"Show command list. (MAME Plus! format \"command.dat\")",
#endif

#if PSP_VIDEO_32BPP
	"Color settings menu",
	"Background image type",
	"Background image blightness",
	"Title bar text",
	"Selected text",
	"Normal text",
	"Information message text",
	"Warning message text",
	"File select bar (start)",
	"File select bar (end)",
	"Title bar/Message box",
	"Title bar/ Message box frame",
	"Background",
	"Red",
	"Green",
	"Blue",
	"Default image",
	"User's image",
	"logo.png only",
	"File select bar",
#endif

	"Command list",

	/* psp/mp3.c */
#if (EMU_SYSTEM == NCDZ)
	"Counld not reopen mp3 file \"%s\".",
	"MP3 decode error.",
	"Could not reserve audio channel for MP3.",
	"Could not start MP3 thread.",
#endif

	/* psp/adhoc.c*/
#ifdef ADHOC
	"Waiting for another PSP to join.\n",
	"Connecting...",
	"Connected.",
	"Disconnecting...",
	"Disconnected.",
	"failed.",
	"Select a server to connect to, or " FONT_TRIANGLE " to return.\n",
	"Waiting for %s to accept the connection.\n",
	"To cancel press " FONT_CROSS ".\n",
	"%s has requested a connection.\n",
	"To accept the connection press " FONT_CIRCLE ", to cancel press " FONT_CROSS ".\n",
#endif

	/* psp/png.c */
	"Could not allocate memory for PNG.",
	"Could not enecode PNG image.",
#if PSP_VIDEO_32BPP || (EMU_SYSTEM == NCDZ)
	"Could not decode PNG image.",
#endif
	"%d bit color PNG image not supported.",

	/* emumain.c */
	"Fatal error",
	"Snapshot saved as \"%s_%02d.png\".",

#if USE_CACHE
	/* common/cache.c */
	"Could not open cache file.\n",
	"Memory not enough.\n",
	"Could not allocate cache memory.\n",
	"%dKB cache allocated.\n",
	"Cache load error!!!\n",
	"Loading cache information data...\n",
	"Unsupported version of cache file \"V%c%c\".\n",
	"Current required version is \"" CACHE_VERSION "\".\n",
	"Please rebuild cache file.\n",
#if (EMU_SYSTEM == CPS2)
	"Could not open sprite block %03x\n",
#elif (EMU_SYSTEM == MVS)
	"PCM cache enabled.\n",
#endif
#endif

	/* common/loadrom.c */
	"Press any button.\n",
	"Could not allocate %s memory.\n",
	"CRC32 not correct. \"%s\"\n",
#if (EMU_SYSTEM == NCDZ)
	"File not found. \"%s\"\n",
#else
	"File not found or CRC32 not correct. \"%s\"\n",
#endif

#ifdef SAVE_STATE
	/* common/state.c */
	"Could not allocate state buffer.",
	"Could not create file \"%s.sv%d\"",
	"Could not open file \"%s.sv%d\"",
	"Saving \"%s.sv%d\"",
	"Loading \"%s.sv%d\"",
#if (EMU_SYSTEM == MVS)
	"Could not reload BIOS. Press any button to exit.",
#elif (EMU_SYSTEM == NCDZ)
	"Could not compress state data.",
	"Could not uncompress state data.",
#endif
#endif

#ifdef COMMAND_LIST
	/* common/cmdlist.c */
	"Command list for this game not found.",
	"Command list - %s",
	"%d/%d items",
	"COMMAND.DAT size reduction",
	"This processing removes the command list of the games not being\n",
	"supported by this emulator from COMMAND.DAT.\n",
	"If you want to reduce the size of command.dat, press " FONT_CIRCLE " button.\n",
	"Otherwise, press " FONT_CROSS " button to return to file browser.\n",
	"Checking COMMAND.DAT format...\n",
	"ERROR: Unknown format.\n",
	"ERROR: Empty file.\n",
	"ERROR: Could not allocate memory.\n",
	"ERROR: Could not rename file.\n",
	"ERROR: Could create output file.\n",
	"Copying \"%s\"...\n",
	"Original size:%dbytes, Result:%dbytes (-%.1f%%)\n",
#endif

	/* emulation core */
	"Done.\n",
	"Exit emulation",
	"Please wait.\n",

	/* inptport.c */
	"Controller: Player 1",
	"Controller: Player %d",
#ifdef ADHOC
	"Lost sync.\n",
	"Paused by %s",
	"Server",
	"Client",
	"Return to Game",
	"Disconnect",
#endif

	/* memintrf.c */
#if (EMU_SYSTEM != NCDZ)
	"Loading \"%s\"\n",
	"Load ROM",
	"Checking ROM info...\n",
	"This game not supported.\n",
	"ROM not found. (zip file name incorrect)\n",
	"Driver for \"%s\" not found.\n",
	"ROM set \"%s\" (parent: %s)\n",
	"ROM set \"%s\"\n",
#endif

#if (EMU_SYSTEM == CPS1)

	/* driver.c */
#ifdef ADHOC
	"Sending EEPROM data.\n",
	"Recieving EEPROM data.\n",
#endif

	/* memintrf.c */
	"rominfo.cps1 not found.\n",
	"Could not allocate memory. (0x8000 bytes)",

#elif (EMU_SYSTEM == CPS2)

	/* cps2crpt.c */
	"Decrypting %d%%\r",
	"Decrypting 100%%\n",

	/* driver.c */
#ifdef ADHOC
	"Sending EEPROM data.\n",
	"Recieving EEPROM data.\n",
#endif

	/* memintrf.c */
	"rominfo.cps2 not found.\n",

#elif (EMU_SYSTEM == MVS)

	/* biosmenu.c */
	"BIOS select menu",
	"BIOS not found.",
	"\"sfix.sfx\" not found.",
	"Select BIOS and press " FONT_CIRCLE " button.",
	"All NVRAM files are removed.\n",

	/* memintrf.c */
	"rominfo.mvs not found.\n",
	"Loading \"sfix.sfx\"\n",
	"Loading \"%s (%s)\"\n",
	"Loading decrypted CPU1 ROM...\n",
	"Loading decrypted GFX2 ROM...\n",
	"Loading decrypted GFX3 ROM...\n",
	"Loading decrypted SOUND1 ROM...\n",
	"Loading decrypted BIOS ROM...\n",
	"Could not allocate memory for sprite data.\n",
	"Try to use sprite cache...\n",
	"Checking BIOS...\n",
	"Allocate \"brza_sram\" memory.\n",
	"Could not allocate \"brza_sram\" memory.\n",
	"This game only work without sound.\n",

#elif (EMU_SYSTEM == NCDZ)

	/* ncdz.c */
	"Error while processing IPL.TXT.",
	"Reset caused by watchdog counter.",

	/* cdrom.c */
	"Could not open file \"%s\".",
	"Could not insert CD-ROM state data.",

	/* vidhrdw.c */
	"CD-ROM speed limit: Off",
	"CD-ROM speed limit: On",

#endif
};

#else

const char *ui_text[UI_TEXT_MAX] =
{
	"\0",
	"\n",

	/* psp/filer.c */
	"΂炭҂B",
	"zipname.%sI[vł܂B",

	/* psp/sound.c */
	"I[fBI`lmۂł܂B",
	"TEhXbhJnł܂B",

	/* psp/ui.c */
	"x: obe[̎ceʂ܂(%d%%)B[dĂI",

	FONT_CIRCLE " N      " FONT_CROSS " ~",
	FONT_CIRCLE " s      " FONT_CROSS " ~",
#ifdef SAVE_STATE
	FONT_CIRCLE " Q[ɖ߂   " FONT_CROSS " j[ɖ߂",
#endif
	"{^ĂB",
	"G~[VJn܂B",
#ifdef ADHOC
	"G~[VJn܂B(AdHoc)",
#endif
	"G~[VI܂B",
	"G~[VZbg܂B",
	"G~[^ċN܂B",
#if (EMU_SYSTEM != NCDZ)
	"̃Q[͓삵܂B",
	"̃Q[͌ł͂ǂĂɓ삵܂񂪁A",
	"CɂȂłB",
#endif
	"̃fBNgfBNgɐݒ肵܂B",
#ifdef SAVE_STATE
	"Xe[gZ[uJn܂B",
	"Xe[g[hJn܂B",
	"܂B",
	"Xe[gf[^폜܂B",
#endif
#if (EMU_SYSTEM == NCDZ)
	"MP3t@CׁACDDA͍Đ܂B",
	"IPL.TXT܂B",
	"NEOGEO CDZBIOSN܂B",
	"NEOGEO CDZBIOS(neocd.bin)܂B",
	"NEOGEO CDZBIOSłB",
	"Q[Nł܂B",
#endif

	"wv - %s",
	"gp܂",
	"{^ƃj[ɖ߂܂",
	"t@CuEU",
	"J[\\ړ",
	"J[\\1y[Wړ",
	"Q[N",
	"Q[N (AdHoc)",
	"G~[^I",
	"BIOSIj[\\",
	"J[ݒ胁j[J",
	"̃wvJ",
	"BIOSN",
	"I𒆂̃fBNgNfBNgɐݒ",
	"lύX",
	"I",
	"Xbg̑I",
	"ύX",
	"s",
	"ڂ̑I",
	"ڂ̑I/l̕ύX",
	"RGB̒l+5",
	"t@CuEUɖ߂",
	"RGB̒l-5",
	"SĂ̒lWɖ߂",
	"XgXN[/ڂI",
	"ڃj[J/",
	"Q[/Cj[ɖ߂",

	/* psp/ui_menu.c */
	"I",
	"It",
	"͂",
	"",
	"L",
	"",
	"Cj[ɖ߂",

	"Q[ݒ胁j[",
	"X^GtFNg",
	"ʊg",
#if (EMU_SYSTEM == CPS1 || EMU_SYSTEM == CPS2)
	"360x270 (4:3)",
	"384x270 (24:17)",
	"480x270 (16:9)",
	"ʂ]",
#else
	"360x270 (4:3)",
	"420x270 (14:9)",
	"480x270 (16:9)",
#endif
	"VBLANK",
	"t[XLbv",
	"t[XLbv",
	"x1",
	"x2",
	"x3",
	"x4",
	"x5",
	"x6",
	"x7",
	"x8",
	"x9",
	"x10",
	"x11",
	"FPS\\",
	"60fpst[",
	"TEhĐ",
	"Tv[g",
	"11025Hz",
	"22050Hz",
	"44100Hz",
	"TEh",
	"0%",
	"10%",
	"20%",
	"30%",
	"40%",
	"50%",
	"60%",
	"70%",
	"80%",
	"90%",
	"100%",
	"Rg[",
	"vC[1",
	"vC[2",
#if (EMU_SYSTEM == CPS1 || EMU_SYSTEM == CPS2)
	"vC[3",
	"vC[4",
#endif
	"PSP CPUNbN",
	"222MHz",
	"266MHz",
	"333MHz",
#if (EMU_SYSTEM == MVS)
	"BIOSW",
#endif
#if (EMU_SYSTEM == MVS || EMU_SYSTEM == NCDZ)
	"VXenݒ",
	"{",
	"AJ",
	"[bp",
#endif
#if (EMU_SYSTEM == MVS)
	"VXe[hݒ",
	"ƒp (AES)",
	"A[P[h (MVS)",
#endif
#if (EMU_SYSTEM == NCDZ)
	"[hʃG~[V",
	"CD-ROMx",
	"CDDAĐ",
	"CDDA",
#endif

	"̓{^ݒ胁j[",
	"gpȂ",
	FONT_UPARROW,
	FONT_DOWNARROW,
	FONT_LEFTARROW,
	FONT_RIGHTARROW,
	FONT_CIRCLE,
	FONT_CROSS,
	FONT_SQUARE,
	FONT_TRIANGLE,
	"LgK",
	"RgK",
	"START",
	"SELECT",
	"",
	"W",
	"",
#if (EMU_SYSTEM == CPS2)
	"vC[1 X^[g",
	"vC[2 X^[g",
#endif
	"%dt[",
	"%dt[",
	FONT_UPARROW,
	FONT_DOWNARROW,
	FONT_LEFTARROW,
	FONT_RIGHTARROW,
#if (EMU_SYSTEM == MVS || EMU_SYSTEM == NCDZ)
	"{^A",
	"{^B",
	"{^C",
	"{^D",
#else
	"{^1",
	"{^2",
	"{^3",
	"{^4",
	"{^5",
	"{^6",
#endif
	"X^[g",
#if (EMU_SYSTEM == NCDZ)
	"ZNg",
#else
	"RC",
	"T[rXRC",
#endif
#if (EMU_SYSTEM == MVS)
	"eXgXCb`",
#elif (EMU_SYSTEM != NCDZ)
	"T[rXXCb`",
#endif
#if (EMU_SYSTEM == MVS || EMU_SYSTEM == NCDZ)
	"{^A A",
	"{^B A",
	"{^C A",
	"{^D A",
#else
	"{^1 A",
	"{^2 A",
	"{^3 A",
	"{^4 A",
	"{^5 A",
	"{^6 A",
#endif
	"AˊԊu",
#if (EMU_SYSTEM == MVS || EMU_SYSTEM == NCDZ)
	"AB ",
	"AC ",
	"AD ",
	"BC ",
	"BD ",
	"CD ",
	"ABC ",
	"ABD ",
	"ACD ",
	"BCD ",
	"ABCD ",
#endif
#if (EMU_SYSTEM != NCDZ)
	"AiOx",
#endif
#if (EMU_SYSTEM == CPS1)
	"_CA (])",
	"_CA (E])",
	"|[Y",
#endif
#if (EMU_SYSTEM == CPS2)
	"ph (])",
	"ph (E])",
#endif
#if (EMU_SYSTEM == MVS)
	"rbO",
	"X[",
	"_uAbv",
	"X^[g/Wv",
	"߂",
	"LZ",
	"xbg",
	"SĂɃxbg/SăLZ",
	"Iy[^j[",
	"NWbgNA",
	"zbp[o",
#endif
	"XN[Vbgۑ",
	"vC[؂ւ",

	"fBbvXCb`ݒ胁j[",
	"̃Q[ɂ̓fBbvXCb`͂܂B",

	"Z[u/[hXe[g",
	"Xbg %d:",
	"f[^Ȃ",
	"[h",
	"폜",
	"Z[u",
	"vCt",
	"Z[u",
	"o[W",
	"t@C\"%s\"폜ł܂łB",

	"Cj[",
	"Q[ݒ",
	"Q[̓ݒύX܂B",
	"̓{^ݒ",
	"̓{^ƘA/zbgL[̐ݒ܂B",
#if (EMU_SYSTEM != NCDZ)
	"fBbvXCb`ݒ",
	"fBbvXCb`̐ݒύX܂B",
#endif
	"G~[VZbg",
	SYSTEM_NAME "̃G~[VZbg܂B",
	"t@CuEUɖ߂",
	"G~[VIAt@CuEUɖ߂܂B",
	"Q[ɖ߂",
	"Q[ʂɖ߂܂B",
	"G~[^I",
	"̃\\tgEFAIAPSP̃j[ɖ߂܂B",
#ifdef COMMAND_LIST
	"R}hXg\\",
	"̃Q[̃R}hꗗ\\܂B",
#endif

#if PSP_VIDEO_32BPP
	"J[ݒ胁j[",
	"wi摜̎",
	"wi摜̖邳",
	"^Cgo[̕",
	"Iꂽ",
	"W̕",
	"񃁃bZ[W̕",
	"xbZ[W̕",
	"t@CIo[(Jn)",
	"t@CIo[(I)",
	"^Cgo[/bZ[W{bNX",
	"^Cgo[/bZ[W{bNX̘g",
	"wiF(wi摜gp)",
	"ԋPx",
	"΋Px",
	"Px",
	"W̉摜",
	"[Ủ摜",
	"logo.pnĝ",
	"t@CIo[",
#endif

	"R}hXg",

	/* psp/mp3.c */
#if (EMU_SYSTEM == NCDZ)
	"MP3t@C\"%s\"ăI[vł܂B",
	"MP3fR[hG[܂B",
	"MP3ĐpI[fBI`lmۂł܂B",
	"MP3XbhJnł܂B",
#endif

	/* psp/adhoc.c*/
#ifdef ADHOC
	"PSP̐ڑҋ@B\n",
	"ڑ...",
	"ڑ܂B",
	"ؒf...",
	"ؒf܂B",
	"ڑs",
	"ڑT[oIB" FONT_TRIANGLE "ƒ~܂B\n",
	"%s̐ڑ҂Ă܂B\n",
	FONT_CROSS "ƒ~܂B\n",
	"%sڑvĂ܂B\n",
	FONT_CIRCLE "ŐڑA" FONT_CROSS "Őڑۂ܂B\n",
#endif

	/* psp/png.c */
	"PNG摜p̃mۂł܂B",
	"PNG摜쐬ł܂B",
#if PSP_VIDEO_32BPP || (EMU_SYSTEM == NCDZ)
	"PNG摜WJł܂B",
#endif
	"%dbitJ[PNG摜ɂ͑ΉĂ܂B",

	/* emumain.c */
	"vIȃG[",
	"XN[Vbg\"%s_%02d.png\"ɕۑ܂B",

#if USE_CACHE
	/* common/cache.c */
	"LbVt@CI[vł܂B\n",
	"܂B\n",
	"LbVmۂł܂B\n",
	"%dKB̃LbVmۂ܂B\n",
	"LbV[hɃG[܂B\n",
	"LbVf[^[h...\n",
	"T|[gĂȂo[W\"V%c%c\"̃LbVt@CłB\n",
	"ݗvLbVt@C̃o[W\"" CACHE_VERSION "\"łB\n",
	"LbVt@C쐬ȂĂB\n",
#if (EMU_SYSTEM == CPS2)
	"XvCgubN%03xI[vł܂B\n",
#elif (EMU_SYSTEM == MVS)
	"PCMLbVgp܂B\n",
#endif
#endif

	/* common/loadrom.c */
	"{^ĂB\n",
	"mۂł܂B(REGION_%s)\n",
	"CRC32܂B\"%s\"\n",
#if (EMU_SYSTEM == NCDZ)
	"t@C܂B\"%s\"\n",
#else
	"t@CȂACRC32܂B\"%s\"\n",
#endif

#ifdef SAVE_STATE
	/* common/state.c */
	"Xe[gp̃obt@mۂł܂B",
	"t@C\"%s.sv%d\"쐬ł܂B",
	"t@C\"%s.sv%d\"I[vł܂B",
	"\"%s.sv%d\"ۑ",
	"\"%s.sv%d\"[h",
#if (EMU_SYSTEM == MVS)
	"BIOS[hł܂B{^ƏI܂B",
#elif (EMU_SYSTEM == NCDZ)
	"Xe[gf[^kł܂B",
	"Xe[gf[^WJł܂B",
#endif
#endif

#ifdef COMMAND_LIST
	/* common/cmdlist.c */
	"̃Q[p̃R}hXg܂B",
	"R}hXg - %s",
	"%d/%d ",
	"COMMAND.DAT TCYk",
	"̃G~[^őΉĂȂQ[̃R}hXg폜A\n",
	"COMMAND.DAT̃t@CTCYk܂B\n",
	"sꍇ́A" FONT_CIRCLE "{^ĂB\n",
	FONT_CROSS "{^Ə𒆎~ăt@CuEUɖ߂܂B\n",
	"COMMAND.DAT ...\n",
	"G[: Ή\"COMMAND.DAT\"t@Č`قȂ܂B\n",
	"G[: ̃t@CłB\n",
	"G[: mۂł܂B\n",
	"G[: t@Cl[ł܂B\n",
	"G[: o̓t@C쐬ł܂B\n",
	"\"%s\" ̃R}hRs[...\n",
	"TCY %dbytes  %dbytes (%.1f%%)\n",
#endif

	/* emulation core */
	"܂B\n",
	"G~[V̏I",
	"΂炭҂B\n",

	/* inptport.c */
	"Rg[[: vC[1",
	"Rg[[: vC[%d",
#ifdef ADHOC
	"܂B\n",
	"%sɂ|[Y",
	"T[o[",
	"NCAg",
	"Q[ĊJ",
	"ؒfďI",
#endif

	/* memintrf.c */
#if (EMU_SYSTEM != NCDZ)
	"[h \"%s\"\n",
	"ROM̃[h",
	"ROM`FbN...\n",
	"̃Q[̓T|[gĂ܂B\n",
	"ROM܂B(zipt@CȂ)\n",
	"\"%s\"̃hCo܂B\n",
	"ROMZbg\"%s\" (eZbg: %s)\n",
	"ROMZbg\"%s\"\n",
#endif

#if (EMU_SYSTEM == CPS1)

	/* driver.c */
#ifdef ADHOC
	"EEPROMf[^𑗐M...\n",
	"EEPROMf[^M...\n",
#endif

	/* memintrf.c */
	"rominfo.cps1܂B\n",
	"mۂł܂B(0x8000oCg)",

#elif (EMU_SYSTEM == CPS2)

	/* cps2crpt.c */
	"s %d%%\r",
	"s 100%%\n",

	/* driver.c */
#ifdef ADHOC
	"EEPROMf[^𑗐M...\n",
	"EEPROMf[^M...\n",
#endif

	"rominfo.cps2܂B\n",

#elif (EMU_SYSTEM == MVS)

	/* biosmenu.c */
	"BIOSIj[",
	"BIOS܂B",
	"\"sfix.sfx\"܂B",
	"BIOSIA" FONT_CIRCLE "{^ĂB",
	"NVRAMt@C͑Sč폜܂B",

	/* memintrf.c */
	"rominfo.mvs܂B\n",
	"[h \"sfix.sfx\"\n",
	"[h \"%s (%s)\"\n",
	"ςCPU1 ROM[h...\n",
	"ςGFX2 ROM[h...\n",
	"ςGFX3 ROM[h...\n",
	"ςSOUND1 ROM[h...\n",
	"ςBIOS ROM[h...\n",
	"XvCgf[^p̃mۂł܂B\n",
	"XvCgLbV̎gp݂܂B\n",
	"BIOS`FbN...\n",
	"\"brza_sram\"pmۂ܂B\n",
	"\"brza_sram\"pmۂł܂łB\n",
	"̃Q[̓TEhȂł삵܂B\n",

#elif (EMU_SYSTEM == NCDZ)

	/* ncdz.c */
	"IPL.TXTɃG[܂B",
	"EHb`hbOJE^ɂ郊Zbg܂B",

	/* cdrom.c */
	"t@C\"%s\"I[vł܂B",
	"CD-ROM̃Xe[gf[^ǉł܂B",

	/* vidhrdw.c */
	"CD-ROMx: ",
	"CD-ROMx: L",

#endif
};

#endif
